
#include "molasses/parser_primitives.h"
namespace molasses {
    parser_context register_integers(parser_context ctx) {
        ctx.types.push_back(std::make_shared<primitive_type>("i8", 1));
        ctx.types.push_back(std::make_shared<primitive_type>("i16", 2));
        ctx.types.push_back(std::make_shared<primitive_type>("i32", 4));
        ctx.types.push_back(std::make_shared<primitive_type>("i64", 8));
        ctx.types.push_back(std::make_shared<primitive_type>("u8", 1));
        ctx.types.push_back(std::make_shared<primitive_type>("u16", 2));
        ctx.types.push_back(std::make_shared<primitive_type>("u32", 4));
        ctx.types.push_back(std::make_shared<primitive_type>("u64", 8));

        return ctx;
    }
}